function newRequest() {
  var xmlhttp=false;

/* Magic comment that includes code for the non-standard IE browser only.
   IE will not work with Active-X disabled - as any sane user would do.
   But this is here to support those insane IE users.  */

/*@cc_on @*/
/*@if (@_jscript_version >= 5)
// JScript gives us Conditional compilation, we can cope with old IE versions.
// and security blocked creation of the objects.
 try {
  xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
 } catch (e) {
  try {
   xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  } catch (E) {
   xmlhttp = false;
  }
 }
@end @*/

  /* Check the standard API */
  if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	  try {
		  xmlhttp = new XMLHttpRequest();
	  } catch (e) {
		  xmlhttp=false;
	  }
  }

  /* Check a less common non-standard API other than IE. */
  if (!xmlhttp && window.createRequest) {
	  try {
		  xmlhttp = window.createRequest();
	  } catch (e) {
		  xmlhttp=false;
	  }
  }
  return xmlhttp;
}

/*global vars*/
var emod;	/* the event model */
var req;	/* The request submitter */
var formMap = new Object();

function makeQuery(frmname) {
  var s = new Array;
  var modifiedFields = formMap[frmname];
  if (modifiedFields != null) {
    if (!("sys$browser" in modifiedFields))
      modifiedFields["sys$browser"] = emod;
    for (var i in modifiedFields) {
      var e = modifiedFields[i];
      var val = e;
      if (typeof(e) == 'string') {
	delete modifiedFields[i];
      }
      else if (e.constructor == Array) {
        for (var j in e) {
	  s.push(i+"="+encodeURIComponent(e[j].value));
	}
	continue;
      }
      else {
	val = e.value;
	if (e.type != "hidden") {
	  delete modifiedFields[i];
	  if (e.type == 'checkbox' && !e.checked) {
	    val = ''
	  }
	}
      }
      s.push(i+"="+encodeURIComponent(val));
    }
  }
  return s.join('&');
}

var getElementsByName = function (nm) { return document.getElementsByName(nm); }

/* Work around IE braindamage still not fixed in IE8 */
function IEgetElementsByName(name) {
  /* IE includes only some tags, and adds the matching id, if any. */
  var temp = document.getElementsByName(name);
  if (temp.length == 0)
    temp = document.getElementsByTagName('SPAN');
  var matches = [];
  var len = temp.length;
  for (var i = 0; i < len; i++) {
    if (temp[i].name == name) {
      matches.push(temp[i]);
    }
  }
  return matches;
}

/* The event handler for the onLoad event. */
function onloadH(e) {
  emod = (e) ? (e.eventPhase) ? "W3C" : "NN4" : (window.event) ? "IE4+" : "unknown";

  /*this extra command is needed for the old netscape browsers*/
  if (emod == "NN4")
     document.captureEvents(Event.CLICK);
  req = newRequest();
  if (emod == 'IE4+') {
    getElementsByName = IEgetElementsByName;
  }
  init();
}

/** Initialization when document is loaded.  Skips stuff in
  onloadH() when reloaded via javascript.  */

function init() {
  var len = document.forms.length;
  for (var i = 0; i < len; ++i)
    initEvents(document.forms[i]);
}

/*assign event handler for onload event*/
window.onload = onloadH;

function initEvents(form) {
  var modifiedFields = new Object();
  formMap[form.id] = modifiedFields;
  function markModified() {
    modifiedFields[this.name] = this;
    return true;
  }
  var len = form.elements.length;
  for (var i = 0; i < len; ++i) {
    var e = form.elements[i];
    if (!e) continue;
    if (e.type == "submit") {
      e.onclick = markModified;
    }
    else if (e.type == "hidden") {
      if (e.name in modifiedFields)
	modifiedFields[e.name].push(e);
      else
	modifiedFields[e.name] = [e];
    }
    else if (!e.onchange)
      e.onchange = markModified;
  }
}

function autoSubmit(elem,sname) {
  var form = elem.form;
  var modifiedFields = formMap[form.id];
  modifiedFields[elem.name] = elem;
  modifiedFields[sname] = form.elements[sname];
  return updateForm(form.id);
}

function virtualPress(formid,name,val) {
  var modifiedFields = formMap[formid];
  modifiedFields[name] = val;
  return updateForm(formid);
}

function updateServer(url,postdata) {
  req.open("POST",url,false);
  req.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
  req.setRequestHeader('Accept','message/x-json-formresult');
  req.send(postdata);
}

function updateForm(f,url) {
  var frm = document.forms[f];
  if (!url) url = frm.action;
  updateServer(url,makeQuery(f));
  if (req.status == 302) {	// redirect
    var url = req.getResponseHeader('Location');
    window.location.replace(url);
    return false;
  }
  var type = req.getResponseHeader('Content-Type');
  if (type.split(';')[0] == 'text/html') {
    /* new form */
    document.open();
    document.write(req.responseText);
    document.close();
    init();
  }
  else if (req.status != 200) {
    alert("Server error: " + req.responseText);
    return false;
  }
  else {
    var local = new Function("return "+req.responseText);
    // update data fields
    update(frm,local());
  }
  return false;
}

/* --- aplication code --- */

function update(frm,formres) {
  if (!formres) return;
  if (formres.replace) {
    window.location.replace(formres.replace);
    return;
  }
  if ('alert' in formres) {
    var msg = formres['alert'];
    alert(msg);
  }
  if ('confirm' in formres) {
    var v = formres['confirm'];
    var e = getElementsByName(v.name);
    var resp = confirm(v.msg);
    for (var i = 0; i < e.length; ++i) {
      var elem = e[i];
      if (elem.value == v.value) {
        elem.checked = resp;
        if (resp) return autoSubmit(elem,v.button);
      }
    }
  }
  if ('redirect' in formres) {
    window.location.replace(formres['redirect']);
    return;
  }
  var newHTML = false;
  if ('formdata' in formres) {
    var d = formres.formdata;
    for (var nm in d) {
      var val = d[nm];
      var elems = getElementsByName(nm);
      if (typeof(val) == 'string') {
	for (var i = 0; i < elems.length; ++i) {
	  var e = elems[i];
	  e.value = val;
	}
      }
      else {
	for (var i = 0; i < elems.length; ++i) {
	  var e = elems[i];
	  var v = val[i] || val; 
	  if (typeof(v) == 'string') {
	    e.disabled = false;
	    e.value = v
	  }
	  else {
	    for (var a in v) {
	      if (a == 'prot') {	// backward compat
		e.innerHTML = v.prot;
		newHTML = true;
	      }
	      else
	        e[a] = v[a];
	    }
	  }
	}
      }
    }
  }
  if ('elemdata' in formres) {
    var p = formres.elemdata;
    for (var nm in p) {
      var val = p[nm];
      var e = document.getElementById(nm);
      if (!e) continue;	/* we don't actually have that element. */
      for (var a in val) {
	e[a] = val[a];
      }
      if ('innerHTML' in val)
	newHTML = true;
    }
  }
  if (newHTML) {
    initEvents(frm);
  }
}
