function newRequest() {
  var xmlhttp=false;

/* Magic comment that includes code for the non-standard IE browser only.
   IE will not work with Active-X disabled - as any sane user would do.
   But this is here to support those insane IE users.  */

/*@cc_on @*/
/*@if (@_jscript_version >= 5)
// JScript gives us Conditional compilation, we can cope with old IE versions.
// and security blocked creation of the objects.
 try {
  xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
 } catch (e) {
  try {
   xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  } catch (E) {
   xmlhttp = false;
  }
 }
@end @*/

  /* Check the standard API */
  if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	  try {
		  xmlhttp = new XMLHttpRequest();
	  } catch (e) {
		  xmlhttp=false;
	  }
  }

  /* Check a less common non-standard API other than IE. */
  if (!xmlhttp && window.createRequest) {
	  try {
		  xmlhttp = window.createRequest();
	  } catch (e) {
		  xmlhttp=false;
	  }
  }
  return xmlhttp;
}

function makeQuery(frm) {
  var s = new Array;
  for (var i = 0; i < frm.elements.length; ++i) {
    var e = frm.elements[i];
    if (e.name)
      s.push(e.name+"="+encodeURIComponent(e.value));
  }
  return s.join('&');
}

function fldFromElem(elem) {
  var fld = elem.name;
  if (fld == "") return fld;
  var el = getElementsByName(fld);
  for (var i = 0; i < el.length; ++i) {
    if (elem == el[i]) {
      fld = [fld,i].join();
      break;
    }
  }
  return fld;
}

// when debug is true, need to define log function
// also see fvlogger for more extensive logging library
function log(msg) {
  console.log(msg)	// logs to mozilla console
}

var saveformres;
var curfld;
var frmev;
var debug = false;
var req;
var waitkey = false;
var poll = 0;
var poll_active = false;
var fldexit = false;
var menu = null;
var keycodeMap = {	// map javascript keycodes to EDX pfkeys
  13:0,33:2,34:3,2067:-1,2099:-1,
  112:1,113:2,114:3,115:4,116:5,
  117:6,118:7,119:8,120:9,121:10,122:11,123:12,
  1112:11,1113:12,1114:13,1115:14,1116:15,
  1117:16,1118:17,1119:18,1120:19,1121:20,1122:21,1123:22
  // I suspect IE8 doesn't like the trailing comma
};

function dumpQuery(q) {
  var a = q.split('&');
  for (var i in a) {
    log(a[i]);
  }
}

var donothing = function() { return false; }	// IE braindamage

function keyDownEvent(e) {
  if (e == null) var e = window.event;	// IE braindamage
  var keyCode = e.keyCode;
  if (!keyCode) keyCode = e.which;	// IE braindamage
  if (emod != "IE4+") {
    if (e.shiftKey) keyCode += 1000;
    if (e.ctrlKey) keyCode += 2000;
    var t = e.target;
    var pf = keycodeMap[keyCode];
    if (waitkey && pf == 10) {
      curfld = t;
      menu.show(e.clientX,e.clientY);
      return false;
    }
  }
}

/* FIXME: assign keyEvent to form
   Default key action can only be disabled for keypress in Opera.
   However, keypress handling of functions keys is different in Mozilla.
 */
function keyEvent(e) {
  if (e == null) var e = window.event;	// IE braindamage
  var keyCode = e.keyCode;
  if (!keyCode) keyCode = e.which;	// IE braindamage
  var isChar = e.isChar;
  if (emod != "IE4+") {
    isChar = (e.charCode > 0);
    if (e.shiftKey) keyCode += 1000;
    if (e.ctrlKey) keyCode += 2000;
  }
  if (!isChar) {
    var p = Popup.cur;
    if (p) {
      if (p.onKeyDown(keyCode)) return false;
    }
    if (keyCode in keycodeMap) {
      curkey = e;
      var t = e.target;
      if (emod == "IE4+") {
        t = e.srcElement;	// IE braindamage
	document.onhelp = donothing;
	window.onhelp = donothing;
      }
      else {
	e.preventDefault();
	e.stopPropagation();
      }
      var pf = keycodeMap[keyCode];
      if (waitkey && pf == 10) {
	curfld = t;
	menu.show(e.clientX,e.clientY);
	return false;
      }
      if (debug)
	log("pfkey:"+pf);
      if (pf < 0)
	pfkey(fldFromElem(t),"attn");
      else
	pfkey(fldFromElem(t),pf);
      return false;
    }
  }
  //log(e.keyCode);
  return true;
}


function pickMenu(f,s) {
  var fld = document.edxweb[f];
  if (fld) {
    fld.value = s;
    fld.focus();
    pfkey(fld.name,0);
  }
  return false;
}

var on_click = function(event) {
  frmev = event;
  var s = this.name;
  if (!s) {
    if (this.href)
      s = this.href.match(/#f\d+/)[0];
    else
      s = "";
  }
  var pf = 0;
  var pfx = s.slice(0,2);
  if (debug)
    log("click:"+s+" name:"+this.name+" href:"+this.href+" pfx:"+pfx);
  if (pfx == 'pf' || pfx == '#f') {
    pf = parseInt(s.slice(2));
  }
  var fld = "unknown";
  if (curfld)
    fld = fldFromElem(curfld);
  pfkey(fld,pf);
  return false;
}

function initEvents(form) {
  /* Track which EDX field had focus last. That will be reported
     as cursor position. */
  function enterEDXField() {
    curfld = this;
    //log(curfld.name);
  }

  function leaveEDXField() {
    if (fldexit)
      pfkey(fldFromElem(this),100);
  }

  var len = form.elements.length;
  for (var i = 0; i < len; ++i) {
    var e = form.elements[i];
    if (!e) continue;
    if (e.type == "submit" || e.type == "button") {
      if (!e.onclick)
	e.onclick = on_click;
    }
    else {
      e.onfocus  = enterEDXField;
      e.onblur = leaveEDXField;
    }
  }
}

var getElementsByName = function (nm) { return document.getElementsByName(nm); }

/* Work around IE braindamage still not fixed in IE8 */
function IEgetElementsByName(name) {
  /* IE includes only some tags, and adds the matching id, if any. */
  var temp = document.getElementsByName(name);
  if (temp.length == 0)
    temp = document.getElementsByTagName('SPAN');
  var matches = [];
  var len = temp.length;
  for (var i = 0; i < len; i++) {
    if (temp[i].name == name) {
      matches.push(temp[i]);
    }
  }
  return matches;
}

function init() {
  if (emod == 'IE4+') {
    getElementsByName = IEgetElementsByName;
    document.onkeydown = keyEvent;
  }
  else {
    document.onkeypress = keyEvent;
    document.onkeydown = keyDownEvent;
  }
  initEvents(document.forms.edxweb);
  req = newRequest();
}


/* Apply data updates from server to data fields. */
function update(frm,formres) {
  //saveformres = formres;	// inspect with js shell for debugging
  if (!formres) return;
  /* if (formres.replace) {
    window.location.replace(formres.replace);
    return;
  } */
  if (formres.navigate) {
    window.open(formres.navigate);
  }
  if (formres.shell) {
    window.location.href = formres.shell;
    oktoleave = true;
  }
  if ('edxmenu' in formres) {
    var t = document.getElementById("edxmenu");
    t.innerHTML = formres.edxmenu;
  }
  if ('edxprog' in formres) {
    var t = document.getElementById("edxprog");
    t.innerHTML = formres.edxprog;
  }
  if ('edxmode' in formres) {
    var t = document.getElementById("edxmode");
    t.innerHTML = formres.edxmode;
  }
  if ('status' in formres) {
    var t = document.getElementById("status");
    t.innerHTML = formres.status;
  }
  var t = document.getElementById("edxterm");
  //t.style.visibility = "hidden";
  if ('edxterm' in formres) {
    t.innerHTML = formres.edxterm;
    initEvents(frm);
  }
  if ('edxdata' in formres) {
    var d = formres.edxdata;
    for (var nm in d) {
      var val = d[nm];
      var elems = getElementsByName(nm);
      if (typeof(val) == 'string') {
	for (var i = 0; i < elems.length; ++i) {
	  var e = elems[i];
	  e.value = val;
	}
      }
      else {
	for (var i = 0; i < elems.length; ++i) {
	  var e = elems[i];
	  var v = val[i]; 
	  if (typeof(v) == 'string') {
	    e.disabled = false;
	    e.value = v
	  }
	  else if ('prot' in v) {
	    if (e.tagName != 'SPAN') {
	      e.disabled = true;
	      e.value = v.prot;
	    }
	    else
	      e.innerHTML = v.prot;
	  }
	}
      }
    }
  }
  if ('protected' in formres) {
    var p = formres['protected'];
    for (var nm in p) {
      var elems = getElementsByName(nm);
      var val = p[nm];
      if (typeof(val) == 'string') {
	for (var i = 0; i < elems.length; ++i) {
	  var e = elems[i];
	  if (e.tagName != 'SPAN') {	// FIXME: inputtable field
	    e.disabled = true;
	    e.value = val;
	  }
	  else
	    e.innerHTML = val;
	}
      }
      else {
	for (var i = 0; i < elems.length; ++i) {
	  var e = elems[i];
	  if (e.tagName != 'SPAN') {
	    e.disabled = true;
	    e.value = val[i];
	  }
	  else
	    e.innerHTML = val[i];
	}
      }
    }
  }
  //t.style.visibility = "visible";
  if ('waitkey' in formres)
    waitkey = formres.waitkey;
  if ('curpos' in formres)
    poscurs(formres.curpos);
}

/* Workaround for braindead IE.  focus() is broken in many contexts, and
  the workaround is to call it from a timer event.  But setTimeout() won't
  take a function object, so we have to use a string with a global var. */
function focus(f) {
  if (emod == "IE4+") {
    curfld = f;
    setTimeout('curfld.focus()',10);
  }
  else	// just call focus() for standard browser (everything except IE)
    f.focus()
}

/* Position cursor to field and line. */
function poscurs(fld) {
  if (typeof(fld) == 'string')
    fld = fld.split(',');
  if (fld.length > 1)
    ln = fld[1];
  else
    ln = 0;
  var fn = fld[0];
  var v = getElementsByName(fn);
  var f = null;
  if (ln in v)
    f = v[ln];
  else if (v.length > 0)
    f = v[0];
  if (f != null && f.tagName != 'SPAN') // FIXME: inputtable field
    focus(f);
  else {
    // embedded input field
    v = getElementsByName(fn+'.qf');
    if (v.length) {
      focus(v[0]);
      v[0].select();
    }
  }
}

var pfkey = function(fld,pf) {
  if (poll_active && poll) {
    clearTimeout(poll);
    poll = 0;
    poll_active = false;
  }
  if (pf == undefined) 
    pf = "poll";
  var frm=document.forms[0];
  if (debug) {
    dumpQuery("curpos="+fld+"&pfkey="+pf+'&'+makeQuery(frm));
    return false;
  }
  req.open("POST",frm.action,false);
  req.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
  req.setRequestHeader('Accept','message/x-json-formresult');
  if (fld != null)
    req.send("curpos="+fld+"&pfkey="+pf+'&'+makeQuery(frm));
  else
    req.send("pfkey="+pf+'&'+makeQuery(frm));
  if (req.status != 200) {
    alert("Server error: " + req.responseText);
    return false;
  }
  var type = req.getResponseHeader('Content-Type');
  if (type.split(';')[0] == 'text/html') {
    oktoleave = true;
    /* new form */
    document.open();
    document.write(req.responseText);
    document.close();
    frm=document.forms[0];
    initEvents(frm);
  }
  else {
    var local = new Function("return "+req.responseText);
    // update data fields
    update(frm,local());
  }
  if (!waitkey && !poll_active) {
    poll_active = true;
    if (emod == 'IE4+')
      poll = setTimeout('poll=0; pfkey(null,"poll"); poll_active=false',1000);
    else
      poll = setTimeout(pfkey.bind(window,null,"poll"),1000);
  }
  return true;
}

/** Create popup menu attached to element. */
function Popup(menu,sel) {
  this.menu = document.getElementById(menu);
  this.sel = document.getElementById(sel);
  this.idx = 0;
  Popup.popups.push(this);
}

Popup.popups = [];
Popup.cur = null;

Popup.clear = function() {
  Popup.popups = [];
}

Popup.prototype.show = function(x,y) {
  var m = this.menu;
  m.style.top = y;
  m.style.left = x;
  m.style.visibility = "visible";
  this.options = m.getElementsByTagName("A");
  var e = this.options[this.idx];
  e.focus();
  Popup.cur = this;
}

Popup.prototype.hide = function() {
  this.menu.style.visibility = "hidden";
  Popup.cur = null;
}

Popup.prototype.onKeyDown = function(keyCode) {
  switch (keyCode) {
  case 38:	// up
    if (this.idx > 0) --this.idx;
    break;
  case 40:	// down
    if (this.idx < this.options.length) ++this.idx;
    break;
  case 27:	// esc
    this.hide();
    return true;
  case 13:	// return
    var e = this.options[this.idx];
    e.click();
    return true;
  default:
    this.hide();
    return false;
  }
  var e = this.options[this.idx];
  e.focus();
  return true;
}

Popup.onMouseDown = function(e) {
  if (emod == "IE4+") e = event;
  if (!isRClick(e)) return true;
  return Popup.onRightClick(e);
}

Popup.onRightClick = function(e) {
  if (emod == "IE4+") e = event;
  for (var i in Popup.popups) {
    var p = Popup.popups[i];
    var sel = p.sel;
    if (debug) {
      log('sel='+sel.name);
    }
    if (inElement(e,sel)) {
      if (emod == "IE4+") {
        curfld = e.srcElement;
        p.show(e.clientX,e.clientY);
        return false;
      }
      curfld = e.target;
      if (emod=="W3C") {
        p.show(e.clientX,e.clientY);
        return false;
      }
      else if (emod == "NN4")
        return false;
    }
  }
  return true;
}

Popup.onClick = function (e) {
   if (emod == "IE4+")
      e = event;

   var p = Popup.cur;
   if (p) {
      p.hide();
      var t = (emod=="IE4+") ? e.srcElement : e.target;   
      if (t.href && p.onclick)
        return p.onclick.apply(t,[e]);
   }

   return true;
}

/*checks if a right-click occurred*/
function isRClick(e)
{   return (emod=="NN4") ? (e.which > 1) : (e.button == 2);   }


/*check if the event happened in an immediate child of the selected element*/
function inElement(e,s) {
  var t = (emod=="IE4+") ? e.srcElement : (emod=="W3C") ? e.target : 0;   
  return (t) ? (t.parentNode == s || (t.form == s && t.type != 'submit')):true;
}

/*event handler for the context menu event.*/
function oncontextH(e)
{   return false;   }

/*The event handler for the onLoad event.*/
function onloadH(e) {
  emod = (e) ? (e.eventPhase) ? "W3C" : "NN4" : (window.event) ? "IE4+" : "unknown";

  /*assign the other event handlers here*/
  document.onmousedown = Popup.onMouseDown;
  document.onrightclick = Popup.onRightClick;
  document.onclick = Popup.onClick;
  /*A*/
  document.oncontextmenu = oncontextH; /*"NN4" ignores this statement*/

  /*this extra command is needed for the old netscape browsers*/
  if (emod == "NN4")
     document.captureEvents(Event.CLICK);
  init();
  menu = new Popup('edxmenu','edxweb');
  menu.onclick = on_click;
  pfkey(null,"poll");
}

function onunloadH(e) {
  if (oktoleave)
    oktoleave = false;
  else {
    pfkey(null,"disc");
    history.go(-1);
  }
}

/* Bind the 'this' param and optional additional arguments to a function.  */
Function.prototype.bind = function(obj) {
  var method = this;
  var temp = function() { return method.apply(obj, arguments); };
  return temp;
}

/* assign event handlers for load/unload events */
window.onload = onloadH;
window.onunload = onunloadH;

/*global vars*/
var emod; /*the event model*/
var oktoleave = false;
